package com.hw.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hw.dao.WechatInfoMapper;
import com.hw.entity.WechatInfo;
import com.hw.form.WechatInfoForm;
import com.hw.service.WechatInfoService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

@Service
public class WhatInfoServiceImpl implements WechatInfoService {

    @Resource
    private WechatInfoMapper wechatInfoMapper;

    @Override
    public PageInfo<List<WechatInfo>> selectList(WechatInfoForm wechatInfoForm) {
        PageHelper.startPage(wechatInfoForm.getPageNo(),wechatInfoForm.getPageSize());
        List<String> list = wechatInfoMapper.selectOldOpenids(wechatInfoForm);
        return new PageInfo(list);
    }

    @Override
    public int batchAdd(List<String> list,String appid) {
        if (list != null && list.size() > 0){
            String openids = wechatInfoMapper.getOpenids(list,appid);
            List<WechatInfo> addList = new ArrayList<>();
            WechatInfo info = null;
            for (String openid:list){
                if (openids != null && openids.contains(openid)){//已保存
                    continue;
                }
                info = new WechatInfo();
                info.setOldAppid(appid);
                info.setOldOpenid(openid);
                addList.add(info);
            }

            if (addList != null && addList.size() > 0){ //批量添加
                return wechatInfoMapper.batchAdd(addList);
            }
        }

        return 0;
    }

    @Override
    public PageInfo<List<String>> selectOldOpenids(WechatInfoForm wechatInfoForm) {
        PageHelper.startPage(wechatInfoForm.getPageNo(),wechatInfoForm.getPageSize());
        List<String> list = wechatInfoMapper.selectOldOpenids(wechatInfoForm);
        return new PageInfo(list);
    }

    @Override
    public int batchUpdate(List<WechatInfoForm> list) {
        if (list != null && list.size() > 0){
            return wechatInfoMapper.batchUpdate(list);
        }
        return 0;
    }

}
